Attribute VB_Name = "HYDRAVB"
'Copyright Kinzinger Systeme GmbH 1998

Option Explicit
' zur Kommunikation mit Digis mu 'no_digis' False sein !!!!
' Global Const no_digis = False
' nur fr Testzwecke wenn DigiS nicht geladen
' Global Const no_digis = True

#If Win32 Then
Type S_DATA_TO_DIGIS
   ' Anzahl der Kanle fr DigiS
   channel_count As Long
   ' Anzahl der Daten pro Kanal dieses Datenpaketes
   data_per_channel As Long
   ' Messende-Flag
   ' TRUE: Ende eines Datensatzes (letztes Datenpaket) einer
   ' Messung (Datensatz)
   last_block As Long
   ' ID-Nummer des Empfngers
   id_number As Long
End Type

'------------------------------------------------------------------
Type S_DATA_FROM_DIGIS
   ' Anzahl der Empfangenen Kanle
   channel_count As Long
   ' Anzahl der Daten pro Kanal dieses Datenpaketes
   data_per_channel As Long
   ' Messende-Flag
   ' TRUE: Ende eines Datensatzes (letztes Datenpaket) einer
   ' Messung
   last_block As Long
End Type

#Else
'------------------------------------------------------------------
Type S_DATA_TO_DIGIS
   ' Anzahl der Kanle fr DigiS
   channel_count As Integer
   ' Anzahl der Daten pro Kanal dieses Datenpaketes
   data_per_channel As Integer
   ' Messende-Flag
   ' TRUE: Ende eines Datensatzes (letztes Datenpaket) einer
   ' Messung (Datensatz)
   last_block As Integer
   ' ID-Nummer des Empfngers
   id_number As Integer
End Type

'------------------------------------------------------------------
Type S_DATA_FROM_DIGIS
   ' Anzahl der Empfangenen Kanle
   channel_count As Integer
   ' Anzahl der Daten pro Kanal dieses Datenpaketes
   data_per_channel As Integer
   ' Messende-Flag
   ' TRUE: Ende eines Datensatzes (letztes Datenpaket) einer
   ' Messung
   last_block As Integer
End Type
#End If

'------------------------------------------------------------------
' Datenfeld fr Kommunikation mit HYDRAVB.DLL
' !!!!!!!!!!!!!!!!!!1 Achtung !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
' Es sollte fr unterschiedliche events unterschiedliche
' Datenpuffer verwendet werden.
' Stellen, bei denen die Kontrolle an Windows zurckgegeben wird
' knnen sonst zum berschreiben dieser Daten fhren.
' Beispiel: Anzeige einer Messagebox oder Dialogbox
Global fdata(10000) As Single

'------------------------------------------------------------------
' Windows
' Declare Function GetDlgCtrlID Lib "User" (ByVal hWnd As Integer) As Integer
' Declare Function set_id_hwnd_vb Lib "hydravb" (ByVal id_number As Integer, ByVal hWnd As Integer, ByVal DlgId As Integer) As Integer

'------------------------------------------------------------------
' Daten an DigiS senden
' Eingabe :
'   button:        Nummer des Ausganges (1..8) , an dem die Daten
'                  aus dem Block herauskommen. Daten fr nicht
'                  angeschlossene Ausgnge werden verworfen.
'   data_to_digis: Angabe von Datenzahl, Kanalzahl, Messende-Flag,
'                  ID-Nummer
'   pdata:         Zeiger auf Datenfeld der zu sendenden Daten
' Ergebnis:
'   0 im Fehlerfall;
'   sonst Anzahl der gepufferten Datenpakete.
#If Win32 Then
Declare Function send_data_to_digis Lib "HYD32VB" (ByVal Button As Long, data_to_digis As S_DATA_TO_DIGIS, pdata As Single) As Long
#Else
Declare Function send_data_to_digis Lib "HYDRAVB" (ByVal Button As Integer, data_to_digis As S_DATA_TO_DIGIS, pdata As Single) As Integer
#End If

'------------------------------------------------------------------
' Prfe ob weitere Daten an DigiS gesendet werden knnen
' Eingabe :
'   button:        Nummer des Ausganges (1..8), an dem die Daten
'                  aus dem Block herauskommen. Daten fr nicht
'                  angeschlossene Ausgnge werden verworfen.
'   data_to_digis: Angabe von Datenzahl, Kanalzahl, Messende-Flag,
'                  ID-Nummer
' Ergebnis:
'   0 :   es knnen keine weitere Daten gesendet werden. Sendepuffer
'         ist noch voll
'   sonst Senden zulssig.
#If Win32 Then
Declare Function test_send_data_to_digis Lib "HYD32VB" (ByVal Button As Long, data_to_digis As S_DATA_TO_DIGIS) As Long
#Else
Declare Function test_send_data_to_digis Lib "HYDRAVB" (ByVal Button As Integer, data_to_digis As S_DATA_TO_DIGIS) As Integer
#End If

'------------------------------------------------------------------
' Daten von DigiS empfangen
' Eingabe :
'   id_number     : ID-Nummer des Digis-Senders
'   button        : Nummer des Einganges (1..8), an dem die Daten
'                   am DigiS-Block empfangen werden.
'   pdata         : Zeiger auf Datenfeld der zu empfangenden Daten
'   max_data_count: maximal zulssige Anzahl der zu empfangenden
'                   Daten (normalerweise Gre des Datenfeldes
'                   pdata)
' Ergebnis:
'   True wenn Daten empfangen wurden;
'   False im Fehlerfall oder wenn keine neuen Daten da sind.
'   data_from_digis: Angabe von Datenzahl, Kanalzahl, Messende-Flag
#If Win32 Then
Declare Function get_data_from_digis Lib "HYD32VB" (ByVal id_number As Long, ByVal Button As Long, data_from_digis As S_DATA_FROM_DIGIS, pdata As Single, ByVal max_data_count As Long) As Long
#Else
Declare Function get_data_from_digis Lib "HYDRAVB" (ByVal id_number As Integer, ByVal Button As Integer, data_from_digis As S_DATA_FROM_DIGIS, pdata As Single, ByVal max_data_count As Integer) As Integer
#End If


' Empfange float Wert von DigiS
Function f_vh_get_value_from_digis(id_number As Integer, Button As Integer, value As Single) As Integer
  Dim data_from_digis As S_DATA_FROM_DIGIS
  Dim ret As Integer
  Dim get_value As Single

  ret = get_data_from_digis(id_number, Button, data_from_digis, get_value, 1)
  ' Wenn Daten empfangen, dann Wert bernehmen, sonst alten Wert lassen
  If (ret) Then
     value = get_value
  End If
  f_vh_get_value_from_digis = ret
End Function

' Sende float Wert an DigiS
Sub f_vh_send_value_to_digis(id_number As Integer, Button As Integer, value As Single)
  Dim data_to_digis As S_DATA_TO_DIGIS
  Dim ret As Integer

  ' Abbruch wenn ohne DigiS
  'If (no_digis) Then
  '  Exit Sub
  'End If

  data_to_digis.channel_count = 1
  data_to_digis.data_per_channel = 1
  data_to_digis.last_block = 1
  data_to_digis.id_number = id_number

  ret = send_data_to_digis(Button, data_to_digis, value)

End Sub

' Einzelnen Float-Wert von Digis holen und in Textelement eintragen
Function f_vh_set_text_value_from_digis(id_number As Integer, Button As Integer, txt_cntrl As Control) As Integer
  Dim data_from_digis As S_DATA_FROM_DIGIS
  Dim ret As Integer
  Dim ret_value As Single

  ret = get_data_from_digis(id_number, Button, data_from_digis, ret_value, 1)
  ' Wenn Daten empfangen, dann Wert bernehmen, sonst alten Wert lassen
  If (ret) Then
     txt_cntrl.Caption = ret_value
  End If
  f_vh_set_text_value_from_digis = ret

End Function

